/*
##########################################################################
# Getdate.c   gets and sets the date using port 13 and the date command. #
#             Developed and tested on x86 linux redhat,slackware.        #
#             Please modify and distribute, this message or my name is   #
#	      not required to remain with this code.	                 #
# 7/27/98     lwc@nmi.net                                                #
#                                                                        #
# Security:   This program needs to be run as root, but please people    #
#             dont set it as setuid root!  This thing uses strcpy()      #
#             which is bad.  I would write a secure version but normal   #
#             users shouldnt be setting the date and time anyway.        #
#             I would do a chmod 500 getdate after installation.         #
##########################################################################*/




#include <stdio.h>	
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <arpa/inet.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h> 


#define PORT 13  /*Port number of time service*/
#define TOTALBYTES 26 /*Total number of bytes for time string.*/
#define MAXBUF 50 
#define MINBUF 10
#define DATESZ 4

void setdate (char buffer[MAXBUF]); /*sloppy command creation and execute.*/

int main(int argc, char *argv[])
{
  struct hostent *hp;
  struct in_addr addr;
  struct sockaddr_in socketptr;
  int sid;	
  char buffer[MAXBUF]; 

  if(argc < 2){
    printf("usage: gettime <hostname>\n");
    return(1);
  }
  hp = gethostbyname(argv[1]);
  if(!hp) {
   printf("Unresolvable hostname %s.",argv[1]);
   exit(1);
  } else {
    	bcopy(hp->h_addr, &addr, sizeof(struct in_addr));
  	sid=socket(AF_INET,SOCK_STREAM,0);
        socketptr.sin_family=AF_INET; 
    	socketptr.sin_port=htons(PORT);
    	socketptr.sin_addr.s_addr=inet_addr( inet_ntoa(addr));
    	connect(sid,&socketptr,sizeof(socketptr));
    	read(sid,&socketptr,TOTALBYTES); 
        strcpy(buffer,(char *)&socketptr);
        setdate(buffer); 
   }
exit(1);
}


void 
setdate (char buffer[MAXBUF])
{
  char day[MINBUF],month[MINBUF],date[DATESZ],time[MINBUF],year[MINBUF],command[256];

  sscanf (buffer,"%s%s%s%s%s",&day,&month,&date,&time,&year);
  /*Format the buffer into parts for command assembly*/
  strcpy (command, "date \0"); /*might want to use abs path here.*/
  if (strstr (month, "Jan"))
    strcat (command, "01");     /*Quick dirty and sloppy C here.*/
  if (strstr (month, "Feb"))
    strcat (command, "02");
  if (strstr (month, "Mar"))
    strcat (command, "03");
  if (strstr (month, "Apr"))
    strcat (command, "04");
  if (strstr (month, "May"))
    strcat (command, "05");
  if (strstr (month, "Jun"))
    strcat (command, "06");
  if (strstr (month, "Jul"))
    strcat (command, "07");
  if (strstr (month, "Aug"))
    strcat (command, "08");
  if (strstr (month, "Sept"))
    strcat (command, "09");
  if (strstr (month, "Oct"))
    strcat (command, "10");
  if (strstr (month, "Nov"))
    strcat (command, "11");
  if (strstr (month, "Dec"))
    strcat (command, "12");
  if (strlen (date) == 1) /*if date is a single digit place a 0 */
    strcat (command, "0");/*in front so date doesnt whine.*/
  strcat (command, date);
  strcat (command, strtok (time, ":"));
  strcat (command, strtok (NULL, ":"));
  strcat (command, year);
  system (command); /*Execute command.*/
}
